#ifndef PROCESS_DATA_H_

#include "caffe/caffe.hpp"

namespace caffe {

template <typename Dtype>
void RunTopKOnLastDimCUDAImpl(const Dtype *input, const int outer_size, const int inner_size, 
  const int k, Dtype* values, int *indices);

template <typename Dtype>
void RunProcess(int *status_data, Dtype *score_data, Dtype *box_data, int *index_data, 
   const int n_samples, const int n_labels, const int n_box, const int n_index, bool shared,
   const float score_threshold, const float overlap_threshold);  

template <typename Dtype>
void RunPostProcess(Dtype *score_data, Dtype *box_data, int *index_data, int *status_data,
    const int n_status, const int n_samples, const int n_labels, const int n_box, const int n_index, bool shared,
    Dtype *output);


}

#endif  // PROCESS_DATA_H_